#pragma once

#include "DataBoardAPI.h"

#include "DataType.h"

#include <climits>

namespace Databoard {

	class Range;

	namespace Type {

		class DATABOARD_API ArrayType : public DataType {
		public:
			ArrayType();
			ArrayType(DataType* componentType);
			ArrayType(DataType* componentType, Range* length);

			virtual ~ArrayType();

			DataType* getComponentType();
			void setComponentType(DataType* componentType);
			int minLength();
			int maxLength();
			Range* getLength();
			void setLength(Range* length);

			virtual std::string writeOut(int indent = 0);

		protected:

			DataType* componentType;
			Range* length;


		};
	}
}
