#pragma once

#include "SimanticsDataParser.h"

#include <string>

namespace Databoard {

	const char* const STR_BOOLEAN = "Boolean";
	const char* const STR_BYTE = "Byte";
	const char* const STR_INTEGER = "Integer";
	const char* const STR_LONG = "Long";
	const char* const STR_FLOAT = "Float";
	const char* const STR_DOUBLE = "Double";
	const char* const STR_STRING = "String";
	const char* const STR_MAP = "Map";
	const char* const STR_UNIT = "Unit";
	const char* const STR_VARIANT = "Variant";

	const char* const STR_PATTERN = "pattern";
	const char* const STR_MIMETYPE = "mimeType";
	const char* const STR_LENGTH = "length";

	const char* const STR_TRUE = "true";
	const char* const STR_FALSE = "false";

	const char* const STR_RANGE = "Range";
	const char* const STR_RANGESPLIT = "..";

	const char* const STR_BRACEOPEN = "(";
	const char* const STR_BRACECLOSE = ")";
	const char* const STR_BRACKETOPEN = "[";
	const char* const STR_BRACKETCLOSE = "]";

	const char* const STR_OPTIONAL = "Optional";
	
	const char* const STR_EMPTY = "";
	const char* const STR_ERROR = "unspecified error";
	const char* const STR_ERROR_VALUE_SMALL = "Value too small.";
	const char* const STR_ERROR_VALUE_LARGE = "Value too large.";

	void printout(pANTLR3_BASE_TREE type);

	std::string removeQuotes(std::string str);

	bool strEquals(const char* a, const char* b);
}
