/*******************************************************************************
 * Copyright (c) 2010- Association for Decentralized Information Management in
 * Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.tests;

import org.simantics.databoard.accessor.reference.ComponentReference;
import org.simantics.databoard.accessor.reference.NameReference;
import org.simantics.databoard.accessor.reference.KeyReference;
import org.simantics.databoard.accessor.reference.LabelReference;
import org.simantics.databoard.accessor.reference.ChildReference;
import org.simantics.databoard.binding.mutable.MutableVariant;

public class Jotakin3 {

	public static void main(String[] args) {
		
		ChildReference ref1 = ChildReference.compile(
				new NameReference("nodes"),
				new KeyReference( MutableVariant.ofInstance("SINE") ),
				new NameReference("value"),
				new ComponentReference(),
				new ComponentReference()
				); 

		ChildReference ref4 = ChildReference.compile(
				new LabelReference("nodes"),
				new LabelReference("SSINE"),
				new LabelReference("value"),
				new LabelReference("o"),
				new LabelReference("v")
				); 
		
		System.out.println(ref1.toPath(true));	
		System.out.println(ref1.toPath(false));	
		
		ChildReference ref2 = ChildReference.parsePath("n-nodes/m-SSINE/n-value/o/v");
		System.out.println(ref2.toPath(true));	
		System.out.println(ref2.toPath(false));	
		
		ChildReference ref3 = ChildReference.parsePath("nodes/SSINE/value/o/v");
		System.out.println(ref3.toPath(true));	
		System.out.println(ref3.toPath(false));
		
		System.out.println( ref1.equals( ref2 ) );
		System.out.println( ref2.equals( ref1 ) );
		
		System.out.println( ref1.equals( ref3 ) );
		System.out.println( ref3.equals( ref1 ) );

		System.out.println( ref3.equals( ref4 ) );
		System.out.println( ref4.equals( ref3 ) );

	}
	
}

