/*******************************************************************************
 * Copyright (c) 2007 VTT Technical Research Centre of Finland and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.tests;

import java.util.concurrent.locks.ReentrantReadWriteLock;

import org.simantics.databoard.Bindings;
import org.simantics.databoard.binding.Binding;

public class Jotakin6 {

	public static class X {
		public int[] array = new int[1024*1024*4];
		public long[] array2 = new long[1024*1024*4];
	}
	
	public static class Y {
	}
	
	public static void main(String[] args) 
	throws Exception {
		
		ReentrantReadWriteLock lock = new ReentrantReadWriteLock();
		
		lock.writeLock().lock();
		lock.readLock().lock();
		lock.readLock().unlock();
		lock.writeLock().unlock();
		
		X x = new X();
		Binding b = Bindings.getBinding(X.class);
		
		int hash = b.hashValue(x);
		
		long startTime = System.currentTimeMillis();
		
		hash = b.hashValue(x);
		
		long elapsedTime = System.currentTimeMillis() - startTime;
		
		System.out.println("hash="+hash+", time="+elapsedTime);
		
	}
	
}

